diff --git a/sys/contrib/dev/acpica/source/include/acoutput.h b/sys/contrib/dev/acpica/source/include/acoutput.h
index fd4e427..67a3798 100644
--- a/sys/contrib/dev/acpica/source/include/acoutput.h
+++ b/sys/contrib/dev/acpica/source/include/acoutput.h
@@ -44,8 +44,6 @@
 #ifndef __ACOUTPUT_H__
 #define __ACOUTPUT_H__
 
-#pragma pack(push) /* Set default struct packing */
-
 /*
  * Debug levels and component IDs. These are used to control the
  * granularity of the output of the ACPI_DEBUG_PRINT macro -- on a
@@ -470,6 +468,4 @@
 #endif /* ACPI_DEBUG_OUTPUT */
 
 
-#pragma pack(pop) /* Restore original struct packing */
-
 #endif /* __ACOUTPUT_H__ */
diff --git a/sys/contrib/dev/acpica/source/include/acparser.h b/sys/contrib/dev/acpica/source/include/acparser.h
index 74389d2..bddd3c1 100644
--- a/sys/contrib/dev/acpica/source/include/acparser.h
+++ b/sys/contrib/dev/acpica/source/include/acparser.h
@@ -46,8 +46,6 @@
 #define __ACPARSER_H__
 
 
-#pragma pack(push) /* Set default struct packing */
-
 #define OP_HAS_RETURN_VALUE             1
 
 /* Variable number of arguments. This field must be 32 bits */
@@ -355,6 +353,4 @@ AcpiPsShow (
     ACPI_PARSE_OBJECT       *op);
 
 
-#pragma pack(pop) /* Restore original struct packing */
-
 #endif /* __ACPARSER_H__ */
diff --git a/sys/contrib/dev/acpica/source/include/acpiosxf.h b/sys/contrib/dev/acpica/source/include/acpiosxf.h
index a97921e..ebbcb6b 100644
--- a/sys/contrib/dev/acpica/source/include/acpiosxf.h
+++ b/sys/contrib/dev/acpica/source/include/acpiosxf.h
@@ -50,8 +50,6 @@
 #include "actypes.h"
 
 
-#pragma pack(push) /* Set default struct packing */
-
 /* Types for AcpiOsExecute */
 
 typedef enum
@@ -553,6 +551,4 @@ AcpiOsCloseDirectory (
 #endif
 
 
-#pragma pack(pop) /* Restore original struct packing */
-
 #endif /* __ACPIOSXF_H__ */
diff --git a/sys/contrib/dev/acpica/source/include/acpixf.h b/sys/contrib/dev/acpica/source/include/acpixf.h
index a88491f..0b01047 100644
--- a/sys/contrib/dev/acpica/source/include/acpixf.h
+++ b/sys/contrib/dev/acpica/source/include/acpixf.h
@@ -47,15 +47,13 @@
 
 /* Current ACPICA subsystem version in YYYYMMDD format */
 
-#define ACPI_CA_VERSION                 0x20140214
+#define ACPI_CA_VERSION                 0x20140325
 
 #include "acconfig.h"
 #include "actypes.h"
 #include "actbl.h"
 #include "acbuffer.h"
 
-#pragma pack(push) /* Set default struct packing */
-
 /*
  * Globals that are publically available
  */
@@ -76,7 +74,7 @@ extern UINT8                AcpiGbl_AutoSerializeMethods;
 extern UINT8                AcpiGbl_CopyDsdtLocally;
 extern UINT8                AcpiGbl_CreateOsiMethod;
 extern UINT8                AcpiGbl_DisableAutoRepair;
-extern UINT8                AcpiGbl_DisableSsdtTableLoad;
+extern UINT8                AcpiGbl_DisableSsdtTableInstall;
 extern UINT8                AcpiGbl_DoNotUseXsdt;
 extern UINT8                AcpiGbl_EnableAmlDebugObject;
 extern UINT8                AcpiGbl_EnableInterpreterSlack;
@@ -204,6 +202,11 @@ AcpiDecodePldBuffer (
  * ACPI table load/unload interfaces
  */
 ACPI_STATUS
+AcpiInstallTable (
+    ACPI_PHYSICAL_ADDRESS   Address,
+    BOOLEAN                 Physical);
+
+ACPI_STATUS
 AcpiLoadTable (
     ACPI_TABLE_HEADER       *Table);
 
@@ -833,6 +836,4 @@ AcpiDebugPrintRaw (
     ...);
 #endif
 
-#pragma pack(pop) /* Restore original struct packing */
-
 #endif /* __ACXFACE_H__ */
diff --git a/sys/contrib/dev/acpica/source/include/acpredef.h b/sys/contrib/dev/acpica/source/include/acpredef.h
index b8b7599..e5caaf6 100644
--- a/sys/contrib/dev/acpica/source/include/acpredef.h
+++ b/sys/contrib/dev/acpica/source/include/acpredef.h
@@ -45,8 +45,6 @@
 #define __ACPREDEF_H__
 
 
-#pragma pack(push) /* Set default struct packing */
-
 /******************************************************************************
  *
  * Return Package types
@@ -1069,6 +1067,4 @@ static const ACPI_PREDEFINED_INFO      AcpiGbl_ScopeNames[] = {
 extern const ACPI_PREDEFINED_INFO      AcpiGbl_ResourceNames[];
 #endif
 
-#pragma pack(pop) /* Restore original struct packing */
-
 #endif
diff --git a/sys/contrib/dev/acpica/source/include/acresrc.h b/sys/contrib/dev/acpica/source/include/acresrc.h
index 5f658a6..f761d3f 100644
--- a/sys/contrib/dev/acpica/source/include/acresrc.h
+++ b/sys/contrib/dev/acpica/source/include/acresrc.h
@@ -49,8 +49,6 @@
 #include "amlresrc.h"
 
 
-#pragma pack(push) /* Set default struct packing */
-
 /*
  * If possible, pack the following structures to byte alignment, since we
  * don't care about performance for debug output. Two cases where we cannot
@@ -439,6 +437,4 @@ extern ACPI_RSDUMP_INFO         AcpiRsDumpUartSerialBus[];
 extern ACPI_RSDUMP_INFO         AcpiRsDumpGeneralFlags[];
 #endif
 
-#pragma pack(pop) /* Restore original struct packing */
-
 #endif  /* __ACRESRC_H__ */
diff --git a/sys/contrib/dev/acpica/source/include/acrestyp.h b/sys/contrib/dev/acpica/source/include/acrestyp.h
index eaea437..b0412aa 100644
--- a/sys/contrib/dev/acpica/source/include/acrestyp.h
+++ b/sys/contrib/dev/acpica/source/include/acrestyp.h
@@ -45,8 +45,6 @@
 #define __ACRESTYP_H__
 
 
-#pragma pack(push) /* Set default struct packing */
-
 /*
  * Definitions for Resource Attributes
  */
@@ -699,6 +697,4 @@ typedef struct acpi_pci_routing_table
 
 } ACPI_PCI_ROUTING_TABLE;
 
-#pragma pack(pop) /* Restore original struct packing */
-
 #endif /* __ACRESTYP_H__ */
diff --git a/sys/contrib/dev/acpica/source/include/acstruct.h b/sys/contrib/dev/acpica/source/include/acstruct.h
index c52db8f..5a0baf4 100644
--- a/sys/contrib/dev/acpica/source/include/acstruct.h
+++ b/sys/contrib/dev/acpica/source/include/acstruct.h
@@ -44,9 +44,6 @@
 #ifndef __ACSTRUCT_H__
 #define __ACSTRUCT_H__
 
-
-#pragma pack(push) /* Set default struct packing */
-
 /* acpisrc:StructDefs -- for acpisrc conversion */
 
 /*****************************************************************************
@@ -273,6 +270,4 @@ typedef struct acpi_walk_info
 #define ACPI_DISPLAY_SHORT          (UINT8) 2
 
 
-#pragma pack(pop) /* Restore original struct packing */
-
 #endif
diff --git a/sys/contrib/dev/acpica/source/include/actables.h b/sys/contrib/dev/acpica/source/include/actables.h
index 19f4e6d..672b6b4 100644
--- a/sys/contrib/dev/acpica/source/include/actables.h
+++ b/sys/contrib/dev/acpica/source/include/actables.h
@@ -45,8 +45,6 @@
 #define __ACTABLES_H__
 
 
-#pragma pack(push) /* Set default struct packing */
-
 ACPI_STATUS
 AcpiAllocateRootTable (
     UINT32                  InitialTableCount);
@@ -65,6 +63,40 @@ AcpiTbScanMemoryForRsdp (
 
 
 /*
+ * tbdata - table data structure management
+ */
+ACPI_STATUS
+AcpiTbGetNextRootIndex (
+    UINT32                  *TableIndex);
+
+void
+AcpiTbInitTableDescriptor (
+    ACPI_TABLE_DESC         *TableDesc,
+    ACPI_PHYSICAL_ADDRESS   Address,
+    UINT8                   Flags,
+    ACPI_TABLE_HEADER       *Table);
+
+ACPI_STATUS
+AcpiTbAcquireTempTable (
+    ACPI_TABLE_DESC         *TableDesc,
+    ACPI_PHYSICAL_ADDRESS   Address,
+    UINT8                   Flags);
+
+void
+AcpiTbReleaseTempTable (
+    ACPI_TABLE_DESC         *TableDesc);
+
+BOOLEAN
+AcpiTbIsTableLoaded (
+    UINT32                  TableIndex);
+
+void
+AcpiTbSetTableLoadedFlag (
+    UINT32                  TableIndex,
+    BOOLEAN                 IsLoaded);
+
+
+/*
  * tbfadt - FADT parse/convert/validate
  */
 void
@@ -96,17 +128,41 @@ AcpiTbResizeRootTableList (
     void);
 
 ACPI_STATUS
-AcpiTbVerifyTable (
+AcpiTbValidateTable (
     ACPI_TABLE_DESC         *TableDesc);
 
-ACPI_TABLE_HEADER *
-AcpiTbTableOverride (
-    ACPI_TABLE_HEADER       *TableHeader,
+void
+AcpiTbInvalidateTable (
     ACPI_TABLE_DESC         *TableDesc);
 
 ACPI_STATUS
-AcpiTbAddTable (
+AcpiTbVerifyTable (
+    ACPI_TABLE_DESC         *TableDesc,
+    char                    *Signature);
+
+void
+AcpiTbOverrideTable (
+    ACPI_TABLE_DESC         *OldTableDesc);
+
+ACPI_STATUS
+AcpiTbAcquireTable (
     ACPI_TABLE_DESC         *TableDesc,
+    ACPI_TABLE_HEADER       **TablePtr,
+    UINT32                  *TableLength,
+    UINT8                   *TableFlags);
+
+void
+AcpiTbReleaseTable (
+    ACPI_TABLE_HEADER       *Table,
+    UINT32                  TableLength,
+    UINT8                   TableFlags);
+
+ACPI_STATUS
+AcpiTbInstallStandardTable (
+    ACPI_PHYSICAL_ADDRESS   Address,
+    UINT8                   Flags,
+    BOOLEAN                 Reload,
+    BOOLEAN                 Override,
     UINT32                  *TableIndex);
 
 ACPI_STATUS
@@ -118,7 +174,7 @@ AcpiTbStoreTable (
     UINT32                  *TableIndex);
 
 void
-AcpiTbDeleteTable (
+AcpiTbUninstallTable (
     ACPI_TABLE_DESC        *TableDesc);
 
 void
@@ -142,15 +198,6 @@ AcpiTbGetOwnerId (
     UINT32                  TableIndex,
     ACPI_OWNER_ID           *OwnerId);
 
-BOOLEAN
-AcpiTbIsTableLoaded (
-    UINT32                  TableIndex);
-
-void
-AcpiTbSetTableLoadedFlag (
-    UINT32                  TableIndex,
-    BOOLEAN                 IsLoaded);
-
 
 /*
  * tbutils - table manager utilities
@@ -187,7 +234,13 @@ AcpiTbCopyDsdt (
     UINT32                  TableIndex);
 
 void
-AcpiTbInstallTable (
+AcpiTbInstallTableWithOverride (
+    UINT32                  TableIndex,
+    ACPI_TABLE_DESC         *NewTableDesc,
+    BOOLEAN                 Override);
+
+ACPI_STATUS
+AcpiTbInstallFixedTable (
     ACPI_PHYSICAL_ADDRESS   Address,
     char                    *Signature,
     UINT32                  TableIndex);
@@ -196,6 +249,4 @@ ACPI_STATUS
 AcpiTbParseRootTable (
     ACPI_PHYSICAL_ADDRESS   RsdpAddress);
 
-#pragma pack(pop) /* Restore original struct packing */
-
 #endif /* __ACTABLES_H__ */
diff --git a/sys/contrib/dev/acpica/source/include/actbl.h b/sys/contrib/dev/acpica/source/include/actbl.h
index 980529e..a419195 100644
--- a/sys/contrib/dev/acpica/source/include/actbl.h
+++ b/sys/contrib/dev/acpica/source/include/actbl.h
@@ -45,8 +45,6 @@
 #define __ACTBL_H__
 
 
-#pragma pack(push) /* Set default struct packing */
-
 /*******************************************************************************
  *
  * Fundamental ACPI tables
@@ -404,12 +402,11 @@ typedef struct acpi_table_desc
 
 /* Masks for Flags field above */
 
-#define ACPI_TABLE_ORIGIN_UNKNOWN       (0)
-#define ACPI_TABLE_ORIGIN_MAPPED        (1)
-#define ACPI_TABLE_ORIGIN_ALLOCATED     (2)
-#define ACPI_TABLE_ORIGIN_OVERRIDE      (4)
-#define ACPI_TABLE_ORIGIN_MASK          (7)
-#define ACPI_TABLE_IS_LOADED            (8)
+#define ACPI_TABLE_ORIGIN_EXTERNAL_VIRTUAL  (0) /* Virtual address, external maintained */
+#define ACPI_TABLE_ORIGIN_INTERNAL_PHYSICAL (1) /* Physical address, internally mapped */
+#define ACPI_TABLE_ORIGIN_INTERNAL_VIRTUAL  (2) /* Virtual address, internallly allocated */
+#define ACPI_TABLE_ORIGIN_MASK              (3)
+#define ACPI_TABLE_IS_LOADED                (8)
 
 
 /*
@@ -442,6 +439,4 @@ typedef struct acpi_table_desc
 #define ACPI_FADT_V3_SIZE       (UINT32) (ACPI_FADT_OFFSET (SleepControl))
 #define ACPI_FADT_V5_SIZE       (UINT32) (sizeof (ACPI_TABLE_FADT))
 
-#pragma pack(pop) /* Restore original struct packing */
-
 #endif /* __ACTBL_H__ */
diff --git a/sys/contrib/dev/acpica/source/include/actbl1.h b/sys/contrib/dev/acpica/source/include/actbl1.h
index bd2df95..ace4da9 100644
--- a/sys/contrib/dev/acpica/source/include/actbl1.h
+++ b/sys/contrib/dev/acpica/source/include/actbl1.h
@@ -45,8 +45,6 @@
 #define __ACTBL1_H__
 
 
-#pragma pack(push) /* Set default struct packing */
-
 /*******************************************************************************
  *
  * Additional ACPI Tables (1)
@@ -1143,6 +1141,8 @@ typedef struct acpi_srat_x2apic_cpu_affinity
 #define ACPI_SRAT_CPU_ENABLED       (1)         /* 00: Use affinity structure */
 
 
-#pragma pack(pop) /* Restore original struct packing */
+/* Reset to default packing */
+
+#pragma pack()
 
 #endif /* __ACTBL1_H__ */
diff --git a/sys/contrib/dev/acpica/source/include/actbl2.h b/sys/contrib/dev/acpica/source/include/actbl2.h
index 514ecb0..ae46ad8 100644
--- a/sys/contrib/dev/acpica/source/include/actbl2.h
+++ b/sys/contrib/dev/acpica/source/include/actbl2.h
@@ -45,8 +45,6 @@
 #define __ACTBL2_H__
 
 
-#pragma pack(push) /* Set default struct packing */
-
 /*******************************************************************************
  *
  * Additional ACPI Tables (2)
@@ -1418,6 +1416,8 @@ typedef struct acpi_table_wdrt
 } ACPI_TABLE_WDRT;
 
 
-#pragma pack(pop) /* Restore original struct packing */
+/* Reset to default packing */
+
+#pragma pack()
 
 #endif /* __ACTBL2_H__ */
diff --git a/sys/contrib/dev/acpica/source/include/actbl3.h b/sys/contrib/dev/acpica/source/include/actbl3.h
index 1afc341..ce69acd 100644
--- a/sys/contrib/dev/acpica/source/include/actbl3.h
+++ b/sys/contrib/dev/acpica/source/include/actbl3.h
@@ -45,8 +45,6 @@
 #define __ACTBL3_H__
 
 
-#pragma pack(push) /* Set default struct packing */
-
 /*******************************************************************************
  *
  * Additional ACPI Tables (3)
@@ -734,6 +732,8 @@ typedef struct acpi_tpm2_control
 } ACPI_TPM2_CONTROL;
 
 
-#pragma pack(pop) /* Restore original struct packing */
+/* Reset to default packing */
+
+#pragma pack()
 
 #endif /* __ACTBL3_H__ */
diff --git a/sys/contrib/dev/acpica/source/include/actypes.h b/sys/contrib/dev/acpica/source/include/actypes.h
index 1fa6c69..4a6e492 100644
--- a/sys/contrib/dev/acpica/source/include/actypes.h
+++ b/sys/contrib/dev/acpica/source/include/actypes.h
@@ -44,8 +44,6 @@
 #ifndef __ACTYPES_H__
 #define __ACTYPES_H__
 
-#pragma pack(push) /* Set default struct packing */
-
 /* acpisrc:StructDefs -- for acpisrc conversion */
 
 /*
@@ -1317,6 +1315,4 @@ typedef struct acpi_memory_list
 #define ACPI_OSI_WIN_8                  0x0C
 
 
-#pragma pack(pop) /* Restore original struct packing */
-
 #endif /* __ACTYPES_H__ */
diff --git a/sys/contrib/dev/acpica/source/include/acutils.h b/sys/contrib/dev/acpica/source/include/acutils.h
index 355e575..5c87313 100644
--- a/sys/contrib/dev/acpica/source/include/acutils.h
+++ b/sys/contrib/dev/acpica/source/include/acutils.h
@@ -45,8 +45,6 @@
 #define _ACUTILS_H
 
 
-#pragma pack(push) /* Set default struct packing */
-
 extern const UINT8                      AcpiGbl_ResourceAmlSizes[];
 extern const UINT8                      AcpiGbl_ResourceAmlSerialBusSizes[];
 
@@ -191,8 +189,8 @@ AcpiUtGetMutexName (
 
 const char *
 AcpiUtGetNotifyName (
-    UINT32                  NotifyValue);
-
+    UINT32                  NotifyValue,
+    ACPI_OBJECT_TYPE        Type);
 #endif
 
 char *
@@ -1101,7 +1099,15 @@ AcpiUtMethodError (
     const char              *Path,
     ACPI_STATUS             LookupStatus);
 
+/*
+ * Utility functions for ACPI names and IDs
+ */
+const AH_PREDEFINED_NAME *
+AcpiAhMatchPredefinedName (
+    char                    *Nameseg);
 
-#pragma pack(pop) /* Restore original struct packing */
+const AH_DEVICE_ID *
+AcpiAhMatchHardwareId (
+    char                    *Hid);
 
 #endif /* _ACUTILS_H */
diff --git a/sys/contrib/dev/acpica/source/include/amlcode.h b/sys/contrib/dev/acpica/source/include/amlcode.h
index 0695185..bc8c0b0 100644
--- a/sys/contrib/dev/acpica/source/include/amlcode.h
+++ b/sys/contrib/dev/acpica/source/include/amlcode.h
@@ -46,9 +46,6 @@
 #ifndef __AMLCODE_H__
 #define __AMLCODE_H__
 
-#pragma pack(push) /* Set default struct packing */
-
-
 /* primary opcodes */
 
 #define AML_NULL_CHAR               (UINT16) 0x00
@@ -512,6 +509,4 @@ typedef enum
 #define AML_METHOD_SYNC_LEVEL       0xF0
 
 
-#pragma pack(pop) /* Restore original struct packing */
-
 #endif /* __AMLCODE_H__ */
diff --git a/sys/contrib/dev/acpica/source/include/amlresrc.h b/sys/contrib/dev/acpica/source/include/amlresrc.h
index 03b1317..23c4400 100644
--- a/sys/contrib/dev/acpica/source/include/amlresrc.h
+++ b/sys/contrib/dev/acpica/source/include/amlresrc.h
@@ -47,8 +47,6 @@
 #define __AMLRESRC_H
 
 
-#pragma pack(push) /* Set default struct packing */
-
 /*
  * Resource descriptor tags, as defined in the ACPI specification.
  * Used to symbolically reference fields within a descriptor.
@@ -576,7 +574,4 @@ typedef union aml_resource
 
 } AML_RESOURCE;
 
-
-#pragma pack(pop) /* Restore original struct packing */
-
 #endif
diff --git a/sys/contrib/dev/acpica/source/include/platform/acgcc.h b/sys/contrib/dev/acpica/source/include/platform/acgcc.h
index 501bf2b..23db324 100644
--- a/sys/contrib/dev/acpica/source/include/platform/acgcc.h
+++ b/sys/contrib/dev/acpica/source/include/platform/acgcc.h
@@ -64,4 +64,15 @@
  */
 #define ACPI_UNUSED_VAR __attribute__ ((unused))
 
+/*
+ * Some versions of gcc implement strchr() with a buggy macro. So,
+ * undef it here. Prevents error messages of this form (usually from the
+ * file getopt.c):
+ *
+ * error: logical '&&' with non-zero constant will always evaluate as true
+ */
+#ifdef strchr
+#undef strchr
+#endif
+
 #endif /* __ACGCC_H__ */
diff --git a/sys/contrib/dev/acpica/source/include/platform/aclinux.h b/sys/contrib/dev/acpica/source/include/platform/aclinux.h
index 097ba3e..994c941 100644
--- a/sys/contrib/dev/acpica/source/include/platform/aclinux.h
+++ b/sys/contrib/dev/acpica/source/include/platform/aclinux.h
@@ -84,12 +84,23 @@
 #include <ctype.h>
 #include <unistd.h>
 
+/* Define/disable kernel-specific declarators */
+
+#ifndef __init
+#define __init
+#endif
+
+#ifndef __iomem
+#define __iomem
+#endif
+
 /* Host-dependent types and defines for user-space ACPICA */
 
 #define ACPI_FLUSH_CPU_CACHE()
 #define ACPI_CAST_PTHREAD_T(Pthread) ((ACPI_THREAD_ID) (Pthread))
 
-#if defined(__ia64__) || defined(__x86_64__) || defined(__aarch64__)
+#if defined(__ia64__)    || defined(__x86_64__) ||\
+    defined(__aarch64__) || defined(__PPC64__)
 #define ACPI_MACHINE_WIDTH          64
 #define COMPILER_DEPENDENT_INT64    long
 #define COMPILER_DEPENDENT_UINT64   unsigned long
diff --git a/sys/contrib/dev/acpica/source/os_specific/service_layers/oslinuxtbl.c b/sys/contrib/dev/acpica/source/os_specific/service_layers/oslinuxtbl.c
index 551f0b7..f6e94c0 100644
--- a/sys/contrib/dev/acpica/source/os_specific/service_layers/oslinuxtbl.c
+++ b/sys/contrib/dev/acpica/source/os_specific/service_layers/oslinuxtbl.c
@@ -55,9 +55,9 @@
 
 /* List of information about obtained ACPI tables */
 
-typedef struct          table_info
+typedef struct osl_table_info
 {
-    struct table_info       *Next;
+    struct osl_table_info   *Next;
     UINT32                  Instance;
     char                    Signature[ACPI_NAME_SIZE];
 
@@ -253,22 +253,22 @@ AcpiOsGetTableByAddress (
     if (TableLength == 0)
     {
         Status = AE_BAD_HEADER;
-        goto ErrorExit;
+        goto Exit;
     }
 
     LocalTable = calloc (1, TableLength);
     if (!LocalTable)
     {
         Status = AE_NO_MEMORY;
-        goto ErrorExit;
+        goto Exit;
     }
 
     ACPI_MEMCPY (LocalTable, MappedTable, TableLength);
 
-ErrorExit:
+Exit:
     OslUnmapTable (MappedTable);
     *Table = LocalTable;
-    return (AE_OK);
+    return (Status);
 }
 
 
@@ -1003,7 +1003,7 @@ OslGetBiosTable (
     if (TableLength == 0)
     {
         Status = AE_BAD_HEADER;
-        goto ErrorExit;
+        goto Exit;
     }
 
     /* Copy table to local buffer and return it */
@@ -1012,16 +1012,16 @@ OslGetBiosTable (
     if (!LocalTable)
     {
         Status = AE_NO_MEMORY;
-        goto ErrorExit;
+        goto Exit;
     }
 
     ACPI_MEMCPY (LocalTable, MappedTable, TableLength);
     *Address = TableAddress;
     *Table = LocalTable;
 
-ErrorExit:
+Exit:
     OslUnmapTable (MappedTable);
-    return (AE_OK);
+    return (Status);
 }
 
 
@@ -1290,7 +1290,7 @@ OslReadTableFromFile (
     {
         fprintf (stderr, "Could not read table header: %s\n", Filename);
         Status = AE_BAD_HEADER;
-        goto ErrorExit;
+        goto Exit;
     }
 
     /* If signature is specified, it must match the table */
@@ -1301,14 +1301,14 @@ OslReadTableFromFile (
         fprintf (stderr, "Incorrect signature: Expecting %4.4s, found %4.4s\n",
             Signature, Header.Signature);
         Status = AE_BAD_SIGNATURE;
-        goto ErrorExit;
+        goto Exit;
     }
 
     TableLength = ApGetTableLength (&Header);
     if (TableLength == 0)
     {
         Status = AE_BAD_HEADER;
-        goto ErrorExit;
+        goto Exit;
     }
 
     /* Read the entire table into a local buffer */
@@ -1320,7 +1320,7 @@ OslReadTableFromFile (
             "%4.4s: Could not allocate buffer for table of length %X\n",
             Header.Signature, TableLength);
         Status = AE_NO_MEMORY;
-        goto ErrorExit;
+        goto Exit;
     }
 
     fseek (TableFile, FileOffset, SEEK_SET);
@@ -1333,7 +1333,7 @@ OslReadTableFromFile (
             fprintf (stderr, "%4.4s: Could not read table content\n",
                 Header.Signature);
             Status = AE_INVALID_TABLE_LENGTH;
-            goto ErrorExit;
+            goto Exit;
         }
 
         Total += Count;
@@ -1343,7 +1343,7 @@ OslReadTableFromFile (
 
     (void) ApIsValidChecksum (LocalTable);
 
-ErrorExit:
+Exit:
     fclose (TableFile);
     *Table = LocalTable;
     return (Status);
diff --git a/sys/contrib/dev/acpica/source/os_specific/service_layers/osunixdir.c b/sys/contrib/dev/acpica/source/os_specific/service_layers/osunixdir.c
index cd01559..835eee3 100644
--- a/sys/contrib/dev/acpica/source/os_specific/service_layers/osunixdir.c
+++ b/sys/contrib/dev/acpica/source/os_specific/service_layers/osunixdir.c
@@ -41,7 +41,7 @@
  * POSSIBILITY OF SUCH DAMAGES.
  */
 
-#include <acpi.h>
+#include "acpi.h"
 
 #include <stdio.h>
 #include <stdlib.h>
diff --git a/sys/contrib/dev/acpica/source/os_specific/service_layers/osunixxf.c b/sys/contrib/dev/acpica/source/os_specific/service_layers/osunixxf.c
index 3610548..224f345 100644
--- a/sys/contrib/dev/acpica/source/os_specific/service_layers/osunixxf.c
+++ b/sys/contrib/dev/acpica/source/os_specific/service_layers/osunixxf.c
@@ -1345,7 +1345,7 @@ AcpiOsWritable (
  *
  * FUNCTION:    AcpiOsSignal
  *
- * PARAMETERS:  Function            - ACPI CA signal function code
+ * PARAMETERS:  Function            - ACPI A signal function code
  *              Info                - Pointer to function-dependent structure
  *
  * RETURN:      Status
diff --git a/sys/contrib/dev/acpica/source/os_specific/service_layers/oswintbl.c b/sys/contrib/dev/acpica/source/os_specific/service_layers/oswintbl.c
index daff7fe..0afde68 100644
--- a/sys/contrib/dev/acpica/source/os_specific/service_layers/oswintbl.c
+++ b/sys/contrib/dev/acpica/source/os_specific/service_layers/oswintbl.c
@@ -222,6 +222,7 @@ AcpiOsGetTableByName (
     HKEY                    SubKey;
     ULONG                   i;
     ACPI_TABLE_HEADER       *ReturnTable;
+    ACPI_STATUS             Status = AE_OK;
 
 
     /*
@@ -294,7 +295,8 @@ AcpiOsGetTableByName (
         {
             fprintf (stderr, "Could not open %s entry: %s\n",
                 Signature, WindowsFormatException (WinStatus));
-            return (AE_ERROR);
+            Status = AE_ERROR;
+            goto Cleanup;
         }
 
         RegCloseKey (Handle);
@@ -313,7 +315,8 @@ AcpiOsGetTableByName (
         {
             fprintf (stderr, "Could not get %s registry entry: %s\n",
                 Signature, WindowsFormatException (WinStatus));
-            return (AE_ERROR);
+            Status = AE_ERROR;
+            goto Cleanup;
         }
 
         if (Type == REG_BINARY)
@@ -326,11 +329,12 @@ AcpiOsGetTableByName (
 
     WinStatus = RegQueryValueEx (Handle, KeyBuffer, NULL, NULL,
         NULL, &DataSize);
-    if (WinStatus != ERROR_SUCCESS)
+    if (WinStatus = ERROR_SUCCESS)
     {
         fprintf (stderr, "Could not read the %s table size: %s\n",
             Signature, WindowsFormatException (WinStatus));
-        return (AE_ERROR);
+        Status = AE_ERROR;
+        goto Cleanup;
     }
 
     /* Allocate a new buffer for the table */
@@ -338,6 +342,7 @@ AcpiOsGetTableByName (
     ReturnTable = malloc (DataSize);
     if (!ReturnTable)
     {
+        Status = AE_NO_MEMORY;
         goto Cleanup;
     }
 
@@ -345,20 +350,21 @@ AcpiOsGetTableByName (
 
     WinStatus = RegQueryValueEx (Handle, KeyBuffer, NULL, NULL,
         (UCHAR *) ReturnTable, &DataSize);
-    if (WinStatus != ERROR_SUCCESS)
+    if (WinStatus = ERROR_SUCCESS)
     {
         fprintf (stderr, "Could not read %s data: %s\n",
             Signature, WindowsFormatException (WinStatus));
         free (ReturnTable);
-        return (AE_ERROR);
+        Status = AE_ERROR;
+        goto Cleanup;
     }
 
-Cleanup:
-    RegCloseKey (Handle);
-
     *Table = ReturnTable;
     *Address = 0;
-    return (AE_OK);
+
+Cleanup:
+    RegCloseKey (Handle);
+    return (Status);
 }
 
 
